//+------------------------------------------------------------------+
//|                                                         eAll.mq4 |
//|                                                          kwadrad |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "kwadrad"
#property link      ""

//---- input parameters

extern int       Rylo=13;
extern int       Zuby=8;
extern int       Guby=5;
extern int       CCIperiod=76;

extern int       StopLoss=88;
extern int       TakeProfit=170;
extern int       TrailingStop=17;
extern int       TrailingStep=2;
extern double    MaximumRisk= 0.9;
extern double    DecreaseFactor= 18.0;

extern int       Rylo_shift=8;
extern int       Zuby_shift=5;
extern int       Guby_shift=3;

extern double    AllFactor= 16.0;


int    Magic=14062010;
int    slippage=3;
//--------------------------------------------------------------------
bool signal_buy()
 {
  if(LIPS(0)>TEETH(0)&& TEETH(0)>JAW(0)&& LIPS(0)-JAW(0)>AllFactor*Point && vCCI(0)>vCCI(1))
  return(true);else return(false);
}
//--------------------------------------------------------------------
bool signal_sell()
 {
  if(LIPS(0)<TEETH(0)&& TEETH(0)<JAW(0)&& JAW(0)-LIPS(0)>AllFactor*Point && vCCI(0)<vCCI(1))
  return(true);else return(false);
 }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   
   CheckForOpen();
   if(OrdersTotal()>0)
    {
     TrailingStop();
    }
   return(0);
//----
   return(0);
  }
  
//--------------------------------------------------------------------
double JAW(int p)
{
double JAW_val=iAlligator(NULL, 0, Rylo, Rylo_shift, Zuby, Zuby_shift,Guby, Guby_shift, MODE_SMMA, PRICE_MEDIAN, MODE_GATORJAW, p);
return(JAW_val);
 }
 //-----------------------------
 double TEETH(int p)
{
double TEETH_val=iAlligator(NULL, 0, Rylo, Rylo_shift, Zuby, Zuby_shift,Guby, Guby_shift, MODE_SMMA, PRICE_MEDIAN, MODE_GATORTEETH, p);
return(TEETH_val);
}
 //-----------------------------
 double LIPS(int p)
{
double LIPS_val=iAlligator(NULL, 0, Rylo, Rylo_shift, Zuby, Zuby_shift,Guby, Guby_shift, MODE_SMMA, PRICE_MEDIAN, MODE_GATORLIPS, p);
return(LIPS_val);
}
//----------------------iCCI(Symbol(),0,12,PRICE_TYPICAL,0)
double vCCI(int p)
{
double var_CCI=iCCI(Symbol(),0,CCIperiod,PRICE_TYPICAL,p);
return(var_CCI);
 }
 //-----------------------------
void CheckForOpen()
 {
  int    ticket;
  
  if(signal_buy() && OrdersTotal()==0) 
   {
   
     ticket=OrderSend(Symbol(),OP_BUY,LotsOptimized(),Bid,slippage,Bid-StopLoss*fPointX(),Bid+TakeProfit*fPointX(),"DZ_expLeManTrend",Magic,0,Blue);
       if(ticket>0)
         {
          if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
         }
       else Print("Error opening BUY order : ",GetLastError()); 
       return(0); 
   }
 if(signal_sell() && OrdersTotal()==0)
   {
     ticket=OrderSend(Symbol(),OP_SELL,LotsOptimized(),Ask,slippage,Ask+StopLoss*fPointX(),Ask-TakeProfit*fPointX(),"DZ_expLeManTrend",Magic,0,Red);
       if(ticket>0)
         {
          if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
         }
       else Print("Error opening SELL order : ",GetLastError()); 
       return(0); 
   }
   return(0);
 }
 //--------------------------------------------------------------------------|
 //                                                     |
 //--------------------------------------------------------------------------|
 double fPointX()
 {
   double PointX = 0;
   if(Digits==5 || Digits==3) 
     {
      PointX = Point * 10;
     }
   if(Digits==4 || Digits==2) 
     {
      PointX = Point;
     }
   return(PointX);
 }  
//+---------------------------------------------------------------------------+
//+------------------------------------------------------------------+
void TrailingStop()
 {
 int cnt,total;
 total=OrdersTotal();
   for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL && OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)  
        {
         if(OrderType()==OP_BUY) 
           {
            if(TrailingStop>0)  
              {                 
               if(Bid-OrderOpenPrice()>fPointX()*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-(TrailingStop+TrailingStep-1)*fPointX())
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask-TrailingStop*fPointX(),OrderTakeProfit(),0,Green);
                     return(0);
                    }
                 }
              }
           }
         else 
           {
            if(TrailingStop>0)  
              {                 
               if((OrderOpenPrice()-Ask)>(fPointX()*TrailingStop))
                 {
                  if(OrderStopLoss()>Ask+(TrailingStop+TrailingStep-1)*fPointX() || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid+TrailingStop*fPointX(),OrderTakeProfit(),0,Red);
                     return(0);
                    }
                 }
              }
           }
        }
     }  
   return(0); 
}
//----------------------------------------------------------------
//-----------------------------------------------------
double LotsOptimized()
  {
   double lot;
   int    orders=HistoryTotal();     // history orders total
   int    losses=0;                  // number of losses orders without a break
//---- select lot size
   lot=NormalizeDouble(AccountFreeMargin()*MaximumRisk/1000.0,2);
//---- calcuulate number of losses orders without a break
   if(DecreaseFactor>0)
     {
      for(int i=orders-1;i>=0;i--)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
         if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL) continue;
         //----
         if(OrderProfit()>0) break;
         if(OrderProfit()<0) losses++;
        }
      if(losses>1) lot=NormalizeDouble(lot-lot*losses/DecreaseFactor,2);
     }
//---- return lot size
   if(lot<0.01) lot=0.01;
   return(lot);
  }
 //+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }

//+------------------------------------------------------------------+